Index: src/peer/channels/Handler.java
===================================================================
--- src/peer/channels/Handler.java	(revision 2)
+++ src/peer/channels/Handler.java	(revision 3)
@@ -1,118 +1,119 @@
-package peer.channels;
-
-import java.net.DatagramPacket;
-
-import chunk.Chunk;
-import disk.ChunkManagement;
-import peer.Peer;
-import peer.protocols.backup.Store;
-import peer.protocols.reclaim.Reclaim;
-import peer.protocols.restore.GetChunk;
-import message.*;
-
-public class Handler implements Runnable {
-
-    Peer peer;
-    DatagramPacket packet;
-    Message msg;
-    MessageHeader msgHeader;
-
-    public Handler(Peer peer, DatagramPacket packet) {
-        this.peer = peer;
-        this.packet = packet;
-    }
-
-    public void parsePacket() {
-        int packetLength = packet.getLength();
-        byte[] rawData = new byte[packetLength];
-        byte[] packetData = this.packet.getData();
-        System.arraycopy(packetData, packet.getOffset(), rawData, 0, packetLength);
-        this.msg = new Message(rawData);
-        this.msgHeader = msg.getHeader();
-    }
-
-    @Override
-    public void run() {
-
-        parsePacket();
-
-        if (this.peer.getPeerId() != this.msgHeader.getSenderId())
-            switch (this.msgHeader.getMessageType()) {
-            case "PUTCHUNK":
-                handlePUTCHUNK();
-                break;
-            case "GETCHUNK":
-                handleGETCHUNK();
-                break;
-            case "CHUNK":
-                handleCHUNK();
-                break;
-            case "DELETE":
-                handleDELETE();
-                break;
-            case "REMOVED":
-                handleREMOVED();
-                break;
-            default:
-                break;
-            }
-    }
-
-    private void handleREMOVED() {
-        String fileId = this.msgHeader.getFileId();
-        int chunkNo = this.msgHeader.getChunkNo();
-        ChunkManagement.getInstance().registerRemoved(fileId, chunkNo);
-
-        Thread t = new Thread(new Reclaim(peer, fileId, chunkNo));
-        t.start();
-        try {
-            t.join();
-        } catch (InterruptedException e) {
-            e.printStackTrace();
-        }
-    }
-
-    public void handlePUTCHUNK() {
-        if (this.peer.getDisk().getFreeSpace() < (packet.getLength())) {
-            System.out.println("Peer " + this.peer.getPeerId() + "- PUTCHUNK request: Not enough space to store chunk");
-            return;
-        }
-
-        Chunk chunk = new Chunk(this.msgHeader.getFileId(), this.msgHeader.getChunkNo(), this.msgHeader.getReplicaDeg(),
-                this.msg.getBody());
-
-        Thread t = new Thread(new Store(peer, chunk));
-        t.start();
-        try {
-            t.join();
-        } catch (InterruptedException e) {
-            e.printStackTrace();
-        }
-
-    }
-
-    public void handleGETCHUNK() {
-        String fileId = this.msgHeader.getFileId();
-        int chunkNo = this.msgHeader.getChunkNo();
-        Thread t = new Thread(new GetChunk(peer, fileId, chunkNo));
-        t.start();
-        try {
-            t.join();
-        } catch (InterruptedException e) {
-            e.printStackTrace();
-        }
-    }
-
-    public void handleCHUNK() {
-        Chunk chunk = new Chunk(this.msgHeader.getFileId(), this.msgHeader.getChunkNo(), this.msgHeader.getReplicaDeg(),
-                this.msg.getBody());
-
-        ChunkManagement.getInstance().addRestoreChunk(chunk);
-    }
-
-    public void handleDELETE() {
-        String fileID = msgHeader.getFileId();
-        this.peer.getDisk().deleteFileDirectory(fileID);
-        ChunkManagement.getInstance().deleteStores(fileID);
-    }
+package peer.channels;
+
+import java.io.IOException;
+import java.net.DatagramPacket;
+
+import chunk.Chunk;
+import disk.ChunkManagement;
+import peer.Peer;
+import peer.protocols.backup.Store;
+import peer.protocols.reclaim.Reclaim;
+import peer.protocols.restore.GetChunk;
+import message.*;
+
+public class Handler implements Runnable {
+
+    Peer peer;
+    DatagramPacket packet;
+    Message msg;
+    MessageHeader msgHeader;
+
+    public Handler(Peer peer, DatagramPacket packet) {
+        this.peer = peer;
+        this.packet = packet;
+    }
+
+    public void parsePacket() {
+        int packetLength = packet.getLength();
+        byte[] rawData = new byte[packetLength];
+        byte[] packetData = this.packet.getData();
+        System.arraycopy(packetData, packet.getOffset(), rawData, 0, packetLength);
+        this.msg = new Message(rawData);
+        this.msgHeader = msg.getHeader();
+    }
+
+    @Override
+    public void run() {
+
+        parsePacket();
+
+        if (this.peer.getPeerId() != this.msgHeader.getSenderId())
+            switch (this.msgHeader.getMessageType()) {
+            case "PUTCHUNK":
+                handlePUTCHUNK();
+                break;
+            case "GETCHUNK":
+                handleGETCHUNK();
+                break;
+            case "CHUNK":
+                handleCHUNK();
+                break;
+            case "DELETE":
+                handleDELETE();
+                break;
+            case "REMOVED":
+                handleREMOVED();
+                break;
+            default:
+                break;
+            }
+    }
+
+    private void handleREMOVED() {
+        String fileId = this.msgHeader.getFileId();
+        int chunkNo = this.msgHeader.getChunkNo();
+        ChunkManagement.getInstance().registerRemoved(fileId, chunkNo);
+
+        Thread t = new Thread(new Reclaim(peer, fileId, chunkNo));
+        t.start();
+        try {
+            t.join();
+        } catch (InterruptedException e) {
+            e.printStackTrace();
+        }
+    }
+
+    public void handlePUTCHUNK() {
+        if (this.peer.getDisk().getFreeSpace() < (packet.getLength())) {
+            System.out.println("Peer " + this.peer.getPeerId() + "- PUTCHUNK request: Not enough space to store chunk");
+            return;
+        }
+
+        Chunk chunk = new Chunk(this.msgHeader.getFileId(), this.msgHeader.getChunkNo(), this.msgHeader.getReplicaDeg(),
+                this.msg.getBody());
+
+        Thread t = new Thread(new Store(peer, chunk));
+        t.start();
+        try {
+            t.join();
+        } catch (InterruptedException e) {
+            e.printStackTrace();
+        }
+
+    }
+
+    public void handleGETCHUNK() {
+        String fileId = this.msgHeader.getFileId();
+        int chunkNo = this.msgHeader.getChunkNo();
+        Thread t = new Thread(new GetChunk(peer, fileId, chunkNo));
+        t.start();
+        try {
+            t.join();
+        } catch (InterruptedException e) {
+            e.printStackTrace();
+        }
+    }
+
+    public void handleCHUNK() {
+        Chunk chunk = new Chunk(this.msgHeader.getFileId(), this.msgHeader.getChunkNo(), this.msgHeader.getReplicaDeg(),
+                this.msg.getBody());
+
+        ChunkManagement.getInstance().addRestoreChunk(chunk);
+    }
+
+    public void handleDELETE() {
+        String fileID = msgHeader.getFileId();
+        this.peer.getDisk().deleteFileDirectory(fileID);
+        ChunkManagement.getInstance().deleteStores(fileID);
+    }
 }
\ No newline at end of file
Index: src/peer/protocols/reclaim/Reclaim.java
===================================================================
--- src/peer/protocols/reclaim/Reclaim.java	(revision 2)
+++ src/peer/protocols/reclaim/Reclaim.java	(revision 3)
@@ -1,31 +1,45 @@
-package peer.protocols.reclaim;
-
-import disk.ChunkManagement;
-import peer.Peer;
-
-/**
- * Reclaim
- */
-public class Reclaim implements Runnable {
-
-    private Peer peer;
-    private String fileId;
-    private int chunkNo;
-
-    public Reclaim(Peer peer, String fileId, int chunkNo) {
-        this.peer = peer;
-        this.fileId = fileId;
-        this.chunkNo = chunkNo;
-    }
-
-    public void reclaim() {
-        
-    }
-
-    @Override
-    public void run() {
-        reclaim();
-    }
-
-    
+package peer.protocols.reclaim;
+
+import chunk.Chunk;
+import disk.ChunkManagement;
+import peer.Peer;
+import peer.protocols.backup.BackupChunk;
+
+/**
+ * Reclaim
+ */
+public class Reclaim implements Runnable {
+
+    private Peer peer;
+    private String fileId;
+    private int chunkNo;
+
+    public Reclaim(Peer peer, String fileId, int chunkNo) {
+        this.peer = peer;
+        this.fileId = fileId;
+        this.chunkNo = chunkNo;
+    }
+
+    public void reclaim() {
+        Chunk chunk = peer.getDisk().getChunk(fileId, chunkNo);
+        if (chunk != null) {
+            try {
+                Thread.sleep((long) (Math.random() * 400 + 1));
+            } catch (InterruptedException e) {
+                e.printStackTrace();
+            }
+            if (ChunkManagement.getInstance().getStores(fileId, chunkNo) < chunk.getRepDegree()) {
+                BackupChunk backupChunk = new BackupChunk(peer, chunk);
+                Thread bThread = new Thread(backupChunk);
+                bThread.start();
+            }
+        }
+
+    }
+
+    @Override
+    public void run() {
+        reclaim();
+    }
+
 }
\ No newline at end of file
Index: src/peer/protocols/restore/Restore.java
===================================================================
--- src/peer/protocols/restore/Restore.java	(revision 2)
+++ src/peer/protocols/restore/Restore.java	(revision 3)
@@ -1,72 +1,71 @@
-package peer.protocols.restore;
-
-import java.io.File;
-import java.io.IOException;
-import java.util.concurrent.BlockingQueue;
-
-import chunk.Chunk;
-import disk.ChunkManagement;
-import message.Message;
-import peer.Peer;
-import peer.channels.Sender;
-import peer.channels.SenderUDP;
-
-/**
- * Restore
- */
-public class Restore implements Runnable {
-
-	private Peer peer;
-	private String filePath;
-	private File file;
-
-	public Restore(Peer peer, String filePath) {
-		this.peer = peer;
-		this.filePath = filePath;
-		file = new File(filePath);
-	}
-
-	public void sendGetChunk(int chunkNo) {
-		Message message = Message.parseGetChunkMessage(Chunk.generateFileId(file), chunkNo, peer);
-		try {
-			peer.sendToMc(message);
-		} catch (IOException e) {
-			e.printStackTrace();
-		}
-	}
-
-	public void restore() {
-		File originalFile = new File(filePath);
-		if (!originalFile.exists()) {
-			System.out.println("file not found");
-			return;
-		}
-		int chunksNo = Chunk.getNumberOfFileChunks(originalFile);
-		Chunk[] chunks = new Chunk[chunksNo];
-		String fileId = Chunk.generateFileId(originalFile);
-		for (int i = 0; i < chunksNo; i++) {
-			sendGetChunk(i + 1);
-			BlockingQueue<Chunk> queue = ChunkManagement.getInstance().getRestoreChunks();
-			try {
-				System.out.println("Waiting for chunk " + (i+1));
-				Chunk chunk = queue.take();
-				if (chunk.getFileID().equals(fileId)){
-					chunks[i] = chunk;
-					System.out.println("received chunk " + chunk.getChunkNo());
-				}
-				else {
-					queue.put(chunk);
-				}
-			} catch (InterruptedException e) {
-				e.printStackTrace();
-			}
-		}
-		peer.getDisk().restoreFile(chunks,originalFile.getName());
-	}
-
-	@Override
-	public void run() {
-		restore();
-	}
-
-}
\ No newline at end of file
+package peer.protocols.restore;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.concurrent.BlockingQueue;
+
+import chunk.Chunk;
+import disk.ChunkManagement;
+import message.Message;
+import peer.Peer;
+import peer.channels.Sender;
+import peer.channels.SenderUDP;
+
+/**
+ * Restore
+ */
+public class Restore implements Runnable {
+
+	private Peer peer;
+	private String filePath;
+	private File file;
+
+	public Restore(Peer peer, String filePath) {
+		this.peer = peer;
+		this.filePath = filePath;
+		file = new File(filePath);
+	}
+
+	public void sendGetChunk(int chunkNo) {
+		Message message = Message.parseGetChunkMessage(Chunk.generateFileId(file), chunkNo, peer);
+		try {
+			peer.sendToMc(message);
+		} catch (IOException e) {
+			e.printStackTrace();
+		}
+	}
+
+	public void restore() {
+		File originalFile = new File(filePath);
+		if (!originalFile.exists()) {
+			System.out.println("file not found");
+			return;
+		}
+		int chunksNo = Chunk.getNumberOfFileChunks(originalFile);
+		Chunk[] chunks = new Chunk[chunksNo];
+		String fileId = Chunk.generateFileId(originalFile);
+		int i=0;
+		while (i < chunksNo) {
+			sendGetChunk(i + 1);
+			BlockingQueue<Chunk> queue = ChunkManagement.getInstance().getRestoreChunks();
+			try {
+				System.out.println("Waiting for chunk " + (i+1));
+				Chunk chunk = queue.take();
+				if (chunk.getFileID().equals(fileId) && chunk.getChunkNo() == i+1){
+					chunks[i] = chunk;
+					i++;
+					System.out.println("received chunk " + chunk.getChunkNo());
+				}
+			} catch (InterruptedException e) {
+				e.printStackTrace();
+			}
+		}
+		peer.getDisk().restoreFile(chunks,originalFile.getName());
+	}
+
+	@Override
+	public void run() {
+		restore();
+	}
+
+}
Index: src/utils/Utils.java
===================================================================
--- src/utils/Utils.java	(revision 2)
+++ src/utils/Utils.java	(revision 3)
@@ -1,49 +1,60 @@
-package utils;
-
-import java.io.File;
-import java.io.IOException;
-
-/**
- * Utils
- */
-public class Utils {
-
-    public static boolean isInteger(String s) {
-        if (s.isEmpty())
-            return false;
-        for (int i = 0; i < s.length(); i++) {
-            if (i == 0 && s.charAt(i) == '-') {
-                if (s.length() == 1)
-                    return false;
-                else
-                    continue;
-            }
-            if (Character.digit(s.charAt(i), 10) < 0)
-                return false;
-        }
-        return true;
-    }
-
-    public static boolean fileExists(String filePath) {
-        return new File(filePath).isFile();
-    }
-
-    public static boolean isFloat(String s) {
-        return s.matches("[0-9]*\\.?[0-9]+");
-    }
-
-    public static boolean deleteDirectoryRecursively(File file) /*throws IOException */{
-        
-        File[] files = file.listFiles();
-        if(files!=null) {
-            for(File f: files) {
-                if(f.isDirectory()) {
-                    deleteDirectoryRecursively(f);
-                } else {
-                    f.delete();
-                }
-            }
-        }
-        return file.delete();
-    }
+package utils;
+
+import java.io.File;
+import java.io.IOException;
+
+/**
+ * Utils
+ */
+public class Utils {
+
+    public static boolean isInteger(String s) {
+        if (s.isEmpty())
+            return false;
+        for (int i = 0; i < s.length(); i++) {
+            if (i == 0 && s.charAt(i) == '-') {
+                if (s.length() == 1)
+                    return false;
+                else
+                    continue;
+            }
+            if (Character.digit(s.charAt(i), 10) < 0)
+                return false;
+        }
+        return true;
+    }
+
+    public static boolean fileExists(String filePath) {
+        return new File(filePath).isFile();
+    }
+
+    public static boolean isFloat(String s) {
+        return s.matches("[0-9]*\\.?[0-9]+");
+    }
+
+    public static boolean deleteDirectoryRecursively(File file) /*throws IOException */{
+        /*if (file.isDirectory()) {
+            File[] entries = file.listFiles();
+            if (entries != null) {
+                for (File entry : entries) {
+                    deleteDirectoryRecursively(entry);
+                }
+            }
+        }
+        return file.delete();
+        if (!file.delete()) {
+            throw new IOException("Failed to delete " + file);
+        }*/
+        File[] files = file.listFiles();
+        if(files!=null) {
+            for(File f: files) {
+                if(f.isDirectory()) {
+                    deleteDirectoryRecursively(f);
+                } else {
+                    f.delete();
+                }
+            }
+        }
+        return file.delete();
+    }
 }
\ No newline at end of file
Index: compile.sh
===================================================================
--- compile.sh	(nonexistent)
+++ compile.sh	(revision 3)
@@ -0,0 +1,2 @@
+find -name *.java > sources.txt
+javac @sources.txt -d ./bin

